//: C10:ChainOfReponsibility.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Přístup pětilétého
#include <iostream>
#include <vector>
#include "../purge.h"
using namespace std;

enum Odpoved { NE, ANO };

class StrategieJaToChci {
public:
  virtual Odpoved mohlBychDostat() = 0;
  virtual ~StrategieJaToChci() {}
};

class ZeptatSeMamky : public StrategieJaToChci {
public:
  Odpoved mohlBychDostat() {
    cout << "Mami? Mohl bych to dostat?" << endl;
    return NE;
  }
};

class ZeptatSeTatky : public StrategieJaToChci {
public:
  Odpoved mohlBychDostat() {
    cout << "Tati, Fakt to potřebuju!" << endl;
    return NE;
  }
};

class ZeptatSeDedecka : public StrategieJaToChci {
public:
  Odpoved mohlBychDostat() {
    cout << "Dědo, už mám narozeniny?" << endl;
    return NE;
  }
};

class ZeptatSeBabicky : public StrategieJaToChci {
public:
  Odpoved mohlBychDostat() {
    cout << "Babi, mám tě moc rád!" << endl;
    return ANO;
  }
};

class JaToChci : public StrategieJaToChci {
  vector<StrategieJaToChci*> retez;
public:
  JaToChci() {
    retez.push_back(new ZeptatSeMamky());
    retez.push_back(new ZeptatSeTatky());
    retez.push_back(new ZeptatSeDedecka());
    retez.push_back(new ZeptatSeBabicky());
  }
  Odpoved mohlBychDostat() {
    vector<StrategieJaToChci*>::iterator it = retez.begin();
    while(it != retez.end())
      if((*it++)->mohlBychDostat() == ANO)
        return ANO;
    // Dosaženo konce bez úspěchu...
    cout << "Bůůůůůůůůůůů!" << endl;
    return NE;
  }
  ~JaToChci() { purge(retez); }
};

int main() {
  JaToChci retez;
  retez.mohlBychDostat();
} ///:~
